﻿using System;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Windows;

namespace LovciPokladu
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application, INotifyPropertyChanged
    {
        private string _serverAddr;
        private int _serverPort;

        private int _gameID;
        private int _movesLeft;
        private int _initialMoves;

        private int _playerX;
        private int _playerY;
        private int _heldTreasure;
        private int _score;

        private int _playerX2;
        private int _playerY2;
        private int _heldTreasure2;
        private int _score2;

        private bool _secondPlayerExists = false;
        private ObservableCollection<MapField> _mapField;

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }

        public string ServerAddr
        {
            get
            {
                return _serverAddr;
            }

            set
            {
                _serverAddr = value;
                OnPropertyChanged("ServerAddr");
            }
        }

        public int ServerPort
        {
            get
            {
                return _serverPort;
            }

            set
            {
                _serverPort = value;
                OnPropertyChanged("ServerPort");
            }
        }

        public int GameID
        {
            get
            {
                return _gameID;
            }

            set
            {
                _gameID = value;
                OnPropertyChanged("GameID");
            }
        }

        public int MovesLeft
        {
            get
            {
                return _movesLeft;
            }

            set
            {
                _movesLeft = value;
                OnPropertyChanged("MovesLeft");
            }
        }

        public int InitialMoves
        {
            get
            {
                return _initialMoves;
            }

            set
            {
                _initialMoves = value;
                OnPropertyChanged("InitialMoves");
            }
        }

        public ObservableCollection<MapField> MapField
        {
            get
            {
                return _mapField;
            }

            set
            {
                _mapField = value;
                OnPropertyChanged("MapField");
            }
        }

        public int PlayerX
        {
            get
            {
                return _playerX;
            }

            set
            {
                _playerX = value;
                OnPropertyChanged("PlayerX");
            }
        }

        public int PlayerY
        {
            get
            {
                return _playerY;
            }

            set
            {
                _playerY = value;
                OnPropertyChanged("PlayerY");
            }
        }

        public int FirstHeldTreasure
        {
            get
            {
                return _heldTreasure;
            }

            set
            {
                _heldTreasure = value;
                OnPropertyChanged("FirstHeldTreasure");
            }
        }

        public int FirstScore
        {
            get
            {
                return _score;
            }

            set
            {
                _score = value;
                OnPropertyChanged("FirstScore");
            }
        }

        public int SecondHeldTreasure
        {
            get
            {
                return _heldTreasure2;
            }

            set
            {
                _heldTreasure2 = value;
                OnPropertyChanged("SecondHeldTreasure");
            }
        }

        public int SecondScore
        {
            get
            {
                return _score2;
            }

            set
            {
                _score2 = value;
                OnPropertyChanged("SecondScore");
            }
        }

        public bool SecondPlayerExists
        {
            get
            {
                return _secondPlayerExists;
            }

            set
            {
                _secondPlayerExists = value;
                OnPropertyChanged("SecondPlayerExists");
            }
        }

        public int SecondPlayerX
        {
            get
            {
                return _playerX2;
            }

            set
            {
                _playerX2 = value;
                OnPropertyChanged("SecondPlayerX");
            }
        }

        public int SecondPlayerY
        {
            get
            {
                return _playerY2;
            }

            set
            {
                _playerY2 = value;
                OnPropertyChanged("SecondPlayerY");
            }
        }
    }
}
