﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;

namespace LovciPokladu
{
    public class MapField : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
        
        private int _x;
        public int X
        {
            get
            {
                return _x;
            }

            set
            {
                _x = value;
                OnPropertyChanged("X");
                OnPropertyChanged("Lol");
            }
        }

        private int _y;
        public int Y
        {
            get
            {
                return _y;
            }

            set
            {
                _y = value;
                OnPropertyChanged("Y");
                OnPropertyChanged("Lol");
            }
        }

        private string _type;
        public string Type
        {
            get
            {
                return _type;
            }

            set
            {
                _type = value;
                System.Diagnostics.Debug.WriteLine(_type);
                OnPropertyChanged("Type");
                OnPropertyChanged("IsEmpty");
                OnPropertyChanged("IsWall");
                OnPropertyChanged("IsFriendlyBase");
                OnPropertyChanged("IsEnemyBase");
                OnPropertyChanged("IsTreasure");
                OnPropertyChanged("TreasureValue");
                OnPropertyChanged("IsPlayer");
                OnPropertyChanged("IsEnemy");
            }
        }

        public bool IsEmpty
        {
            get
            {
                return _type == "..";
            }
        }

        public bool IsWall
        {
            get
            {
                return _type == "XX";
            }
        }

        public bool IsFriendlyBase
        {
            get
            {
                return _type == "++";
            }
        }

        public bool IsEnemyBase
        {
            get
            {
                return _type == "--";
            }
        }

        public bool IsTreasure
        {
            get
            {
                return Char.IsNumber(_type[0]) && Char.IsNumber(_type[1]);
            }
        }

        public bool IsPlayer
        {
            get
            {
                return _type == "PLAYER";
            }
        }

        public bool IsEnemy
        {
            get
            {
                return _type == "ENEMY";
            }
        }

        public int TreasureValue
        {
            get
            {
                int treasureValue = 0;
                Int32.TryParse(_type, out treasureValue);
                return treasureValue;
            }
        }
    }
}
